<?php
$scriptname = "editrail.php";
$scriptversion = "0.20";
$url = "http://localhost/gh/rail/".$scriptname;

$configfile = "railconf.txt";
$unit = 8;
$toolunit = 24;
$offsetx = $toolunit * 2;
$offsety = 0;
$screenw = $offsetx + $unit * 100;
$screenh = $unit * 100;


$query = @$_SERVER["QUERY_STRING"]."";
if ($query == "__image_type") {
	$w0 = $toolunit * 3;
	$h0 = $toolunit;
	$gp0 = imagecreatetruecolor($w0, $h0) or die("imagecreate failed.");
	$c0 = imagecolorresolve($gp0, 0xff, 0xff, 0xff);
	$c1 = imagecolorresolve($gp0, 0, 0, 0);
	imagefilledrectangle($gp0, 0, 0, $w0, $h0, $c1);
	imagefilledrectangle($gp0, 1, 1, $w0 - 3, $h0 - 3, $c0);
	
	imagestring($gp0, 4, 8, 4, "A", $c1);
	imagestring($gp0, 4, 8 + $toolunit, 4, "P", $c1);
	imagestring($gp0, 4, 8 + $toolunit * 2, 4, "p", $c1);
	
	header("Content-Type: image/png");
	imagepng($gp0);
	imagedestroy($gp0);
	die();
}


function	str2xy($str)
{
	global	$offsetx, $offsety;
	global	$unit;
	
	return array((substr($str, 0, 2) + 0) * $unit + $unit / 2 + $offsetx, (substr($str, 2, 2) + 0) * $unit + $unit / 2 + $offsety);
}

function	crossproduct($x0, $y0, $x1, $y1, $x2, $y2) {
	return ($x1 - $x0) * ($y2 - $y0) - ($x2 - $x0) * ($y1 - $y0);
}


class	rail {
	var	$number, $start, $end;
	var	$trainname = null;
	var	$id;
	var	$len, $vx, $vy;
	function	rail($number = "00", $start = "0000", $end = "0000", $id = 0) {
		$this->number = $number;
		$this->start = $start;
		$this->end = $end;
		$this->id = $id;
		$this->setcoords();
	}
	function	setcoords() {
		global	$unit;
		
		list($sx, $sy) = str2xy($this->start);
		list($ex, $ey) = str2xy($this->end);
		
		$vx = $ex - $sx;
		$vy = $ey - $sy;
		$this->len = sqrt($vx * $vx + $vy * $vy);
		$this->vx = round($vx * $unit / 2 / $this->len);
		$this->vy = round($vy * $unit / 2 / $this->len);
	}
	function	getstart() {
		return $this->start;
	}
	function	getend() {
		return $this->end;
	}
	function	setxy($start = "0000", $end = "0000") {
		$this->start = $start;
		$this->end = $end;
		$this->setcoords();
	}
	function	setnumber($number) {
		$this->number = $number;
	}
	function	getnumber() {
		return $this->number;
	}
	function	settrainname($name) {
		global	$trainnamestring;
		
		if ($name === "") {
			$name = "z";
			if ($trainnamestring == "")
				$name = "A";
			else if (ereg("([^{$trainnamestring}])", "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz", $array))
				$name = $array[1];
		}
		$this->trainname = $name;
		if ($name !== null)
			$trainnamestring .= $name;
	}
	function	gettrainname() {
		return $this->trainname;
	}
	function	getpointnumber() {
		return null;
	}
	function	isactive() {
		return 1;
	}
	function	pick($x, $y) {
		list($sx, $sy) = str2xy($this->start);
		list($ex, $ey) = str2xy($this->end);
		$vx = $this->vx;
		$vy = $this->vy;
		
		$x0 = $sx + $vy;
		$y0 = $sy - $vx;
		$x1 = $ex + $vy;
		$y1 = $ey - $vx;
		$x2 = $ex - $vy;
		$y2 = $ey + $vx;
		$x3 = $sx - $vy;
		$y3 = $sy + $vx;
		
		if (crossproduct($x0, $y0, $x1, $y1, $x, $y) < 0)
			return 0;
		if (crossproduct($x1, $y1, $x2, $y2, $x, $y) < 0)
			return 0;
		if (crossproduct($x2, $y2, $x3, $y3, $x, $y) < 0)
			return 0;
		if (crossproduct($x3, $y3, $x0, $y0, $x, $y) < 0)
			return 0;
		return 1;
	}
	function	pick_rect($l, $t, $r, $b) {
		list($sx, $sy) = str2xy($this->start);
		list($ex, $ey) = str2xy($this->end);
		
		if (($sx < $l)||($sx > $r)||($sy < $t)||($sy > $b))
			return 0;
		if (($ex < $l)||($ex > $r)||($ey < $t)||($ey > $b))
			return 0;
		return 1;
	}
	function	draw($gp) {
		global	$systemstatus;
		global	$unit;
		
		list($sx, $sy) = str2xy($this->start);
		list($ex, $ey) = str2xy($this->end);
		$vx = $this->vx;
		$vy = $this->vy;
		
		$c = imagecolorresolve($gp, 0, 0, 0);
		if (($i = $systemstatus->getspeed($this->number)) == 0) {
			$array = array($sx + $vx * 2, $sy + $vy * 2, $sx - $vy, $sy + $vx, $ex - $vy - $vx * 2, $ey + $vx - $vy * 2, $ex, $ey, $ex + $vy - $vx * 2, $ey - $vx - $vy * 2, $sx + $vy, $sy - $vx);
			imagepolygon($gp, $array, 6, $c);
			return;
		}
		
		if ($i > 0) {
			$c = imagecolorresolve($gp, 0xff, 0x80, 0xff);
			$array = array($sx + $vx * 2, $sy + $vy * 2, $sx - $vy, $sy + $vx, $ex - $vy - $vx * 2, $ey + $vx - $vy * 2, $ex, $ey, $ex + $vy - $vx * 2, $ey - $vx - $vy * 2, $sx + $vy, $sy - $vx);
		} else {
			$c = imagecolorresolve($gp, 0x40, 0xff, 0xff);
			$array = array($sx, $sy, $sx - $vy + $vx * 2, $sy + $vx + $vy * 2, $ex - $vy, $ey + $vx, $ex - $vx * 2, $ey - $vy * 2, $ex + $vy, $ey - $vx, $sx + $vy + $vx * 2, $sy - $vx + $vy * 2);
		}
		imagefilledpolygon($gp, $array, 6, $c);
	}
	function	drawtrain($gp) {
		if ($this->trainname === null)
			return;
		list($sx, $sy) = str2xy($this->start);
		list($ex, $ey) = str2xy($this->end);
		$vx = $this->vx;
		$vy = $this->vy;
		
		$c0 = imagecolorresolve($gp, 0xff, 0xff, 0xff);
		$c1 = imagecolorresolve($gp, 0, 0, 0);
		
		$x = floor(($sx + $ex) / 2);
		$y = floor(($sy + $ey) / 2);
		imagefilledrectangle($gp, $x - 4, $y - 8, $x + 4, $y + 8, $c1);
		imagestring($gp, 4, $x - 4, $y - 8, $this->trainname, $c0);
	}
	function	gethtml($type) {
		global	$systemstatus;
		global	$unit;
		global	$offsetx, $offsety;
		
		switch ($type) {
			case	"selectscript":
				list($sx, $sy) = str2xy($this->start);
				list($ex, $ey) = str2xy($this->end);
				$left = min($sx, $ex) - $unit / 2;
				$top = min($sy, $ey) - $unit / 2;
				$right = max($ex, $sx) + $unit / 2;
				$bottom = max($ey, $sy) + $unit / 2;
				return <<<EOO
	if ((e.pageX >= {$left})&&(e.pageX < {$right})&&(e.pageY >= {$top})&&(e.pageY < {$bottom}))
		return dragmove(e);

EOO;
			case	"selectrectscript":
				list($sx, $sy) = str2xy($this->start);
				list($ex, $ey) = str2xy($this->end);
				$left = min($sx, $ex) - 1 - $unit / 2;
				$top = min($sy, $ey) - 1 - $unit / 2;
				$width = abs($ex - $sx) + 3 + $unit;
				$height = abs($ey - $sy) + 3 + $unit;
				return <<<EOO
	obj = document.createElementNS("http://www.w3.org/2000/svg", "rect");
	obj.setAttribute("stroke", "black");
	obj.setAttribute("fill", "none");
	obj.setAttribute("x", {$left});
	obj.setAttribute("y", {$top});
	obj.setAttribute("width", {$width});
	obj.setAttribute("height", {$height});
	selectobj.appendChild(obj);

EOO;
			case	"pickrectscript":
				list($sx, $sy) = str2xy($this->start);
				list($ex, $ey) = str2xy($this->end);
				$sxv = floor(($sx - $offsetx) / $unit);
				$syv = floor(($sy - $offsety) / $unit);
				$exv = floor(($ex - $offsetx) / $unit);
				$eyv = floor(($ey - $offsety) / $unit);
				$sx -= $unit / 2;
				$sy -= $unit / 2;
				$ex -= $unit / 2;
				$ey -= $unit / 2;
				return <<<EOO
	
	pickrectobj_s.setAttribute("x", {$sx});
	pickrectobj_s.setAttribute("y", {$sy});
	pickrectobj_s.setAttribute("width", {$unit});
	pickrectobj_s.setAttribute("height", {$unit});
	
	pickrectobj_e.setAttribute("x", {$ex});
	pickrectobj_e.setAttribute("y", {$ey});
	pickrectobj_e.setAttribute("width", {$unit});
	pickrectobj_e.setAttribute("height", {$unit});
	
	document.forms[0].sx.value = {$sxv};
	document.forms[0].sy.value = {$syv};
	document.forms[0].ex.value = {$exv};
	document.forms[0].ey.value = {$eyv};

EOO;
		}
	}
	function	getselectarea(&$l, &$t, &$r, &$b) {
		global	$unit;
		
		list($sx, $sy) = str2xy($this->start);
		list($ex, $ey) = str2xy($this->end);
		$left = min($sx, $ex) - 1 - $unit / 2;
		$top = min($sy, $ey) - 1 - $unit / 2;
		$right = max($ex, $sx) + 2 + $unit / 2;
		$bottom = max($ey, $sy) + 2 + $unit / 2;
		
		$l = min($l, $left);
		$t = min($t, $top);
		$r = max($r, $right);
		$b = max($b, $bottom);
	}
	function	getconfig() {
		$ret = sprintf("R%s,%s,%s\n", $this->number, $this->start, $this->end);
		$ret .= $this->getconfig_train();
		return $ret;
	}
	function	getconfig_train() {
		if ($this->trainname === null)
			return "";
		return sprintf("T%s,%s,%s,50\n", $this->trainname, $this->start, $this->end);
	}
}


class	point	extends	rail {
	var	$pointtype, $pointnumber;
	
	function	point($number = "00", $start = "0000", $end = "0000", $pointtype = "P", $pointnumber = "00", $id = 0) {
		parent::rail($number, $start, $end, $id);
		$this->pointtype = $pointtype;
		$this->pointnumber = $pointnumber;
	}
	function	settrainname($name) {
		return;
	}
	function	getpointnumber() {
		return $this->pointnumber;
	}
	function	isactive() {
		global	$systemstatus;
		
		$type = $systemstatus->getstatus($this->pointnumber);
		if (($type !== "P")&&($type !== "p"))
			return -1;
		if ($this->pointtype === $type)
			return 1;
		return 0;
	}
	function	draw($gp) {
		global	$unit;
		
		if (($status = $this->isactive()) > 0) {
			parent::draw($gp);
			return;
		}
		
		list($sx, $sy) = str2xy($this->start);
		list($ex, $ey) = str2xy($this->end);
		
		$c = imagecolorresolve($gp, 0, 0, 0);
		imageline($gp, $sx, $sy, $ex, $ey, $c);
		if ($status == 0) {
			imageline($gp, $sx, $sy, $ex, $ey, $c);
			return;
		}
		
		$vx = $this->vx;
		$vy = $this->vy;
		
		$c = imagecolorresolve($gp, 0xff, 0xff, 0);
		$array = array($sx - $vy, $sy + $vx, $ex - $vy, $ey + $vx, $ex + $vy, $ey - $vx, $sx + $vy, $sy - $vx);
		imagefilledpolygon($gp, $array, 4, $c);
	}
	function	getconfig() {
		$ret = sprintf("%s%s%s,%s,%s\n", $this->pointtype, $this->pointnumber, $this->number, $this->start, $this->end);
		$ret .= $this->getconfig_train();
		return $ret;
	}
}


class	railstatus {
	var	$status = "";
	function	railstatus($status = "") {
		$this->setconfig($status);
	}
	function	setconfig($status = "") {
		$i = 256 - strlen($status);
		if ($i > 0)
			$status .= str_repeat("A", $i);
		$this->status = $status;
	}
	function	getconfig($msec = 0) {
		return sprintf("S%04d,%s\n", $msec, $this->status);
	}
	function	getstatus($number = "00") {
		return substr($this->status, ("0x".$number) + 0, 1);
	}
	function	getspeed($number = "00") {
		$status = $this->getstatus($number);
		if (strpos("BCDEF", $status) !== FALSE)
			return 1;
		if (strpos("bcdef", $status) !== FALSE)
			return -1;
		return 0;
	}
	function	setstatus($number = "00", $status = "A") {
		$pos = ("0x".$number) + 0;
		$this->status = substr($this->status, 0, $pos).$status.substr($this->status, $pos + 1);
	}
}


class	systemstatus extends railstatus {
	var	$mode_edit = 0;
	var	$selectlist;
	var	$attr_train = 0;
	var	$attr_rail = "00";
	var	$attr_point = null;
	function	setmode($mode = 0) {
		$this->mode_edit = $mode + 0;
		$this->selectlist = array();
	}
	function	setrail($rail = "00") {
		$this->attr_rail = $rail;
	}
	function	setpoint($point = null) {
		$this->attr_point = $point;
	}
	function	settrain($train = 0) {
		$this->attr_train = $train + 0;
	}
	function	selectcount() {
		return count($this->selectlist);
	}
	function	getselectlist() {
		if (count($this->selectlist) < 1)
			return array();
		ksort($this->selectlist);
		return array_keys($this->selectlist);
	}
	function	getselectone() {
		$list = $this->getselectlist();
		if (count($list) < 1)
			return null;
		return $list[0];
	}
	function	setselect($id) {
		global	$raillist;
		
		if ($this->mode_edit != 0)
			return;
		if ($id === null) {
			$this->selectlist = array();
			return;
		}
		if (@$raillist[$id] === null)
			return;
		$this->selectlist[$id] = 1;
	}
	function	draw($gp) {
		global	$toolunit, $screenh;
		global	$raillist;
		
		$c0 = imagecolorresolve($gp, 0xff, 0xff, 0xff);
		$c1 = imagecolorresolve($gp, 0, 0, 0);
		$c_gray = imagecolorresolve($gp, 0xe0, 0xe0, 0xe0);
		$c_forward = imagecolorresolve($gp, 0xff, 0xc0, 0xff);
		$c_backward = imagecolorresolve($gp, 0xc0, 0xff, 0xff);
		$c_point = imagecolorresolve($gp, 0xff, 0xff, 0x80);
		
		$l = 2;
		$c = $toolunit;
		$r = $toolunit * 2 - 2;
		$y = 0;
		imagerectangle($gp, $l, $y + 2, $r, $y + 22, $c1);
		
		imagesetstyle($gp, array($c0, $c0, $c1, $c1));
		imagesetthickness($gp, 2);
		imagerectangle($gp, $l + 5, $y + 8, $c - 5, $y + 16, IMG_COLOR_STYLED);
		imagesetthickness($gp, 1);
		if ($this->mode_edit == 0) {
			imagesetthickness($gp, 2);
			imagerectangle($gp, $l + 3, $y + 5, $c - 3, $y + 19, $c1);
			imagesetthickness($gp, 1);
		}
		
		imagepolygon($gp, array($c + 5, $y + 10, $r - 7, $y + 10, $r - 5, $y + 12, $r - 7, $y + 14, $c + 5, $y + 14), 5, $c1);
		if ($this->mode_edit == 1) {
			imagesetthickness($gp, 2);
			imagerectangle($gp, $c + 3, $y + 5, $r - 3, $y + 19, $c1);
			imagesetthickness($gp, 1);
		}
		
		$y += $toolunit;
		
		$color = (($this->mode_edit == 0)&&($this->selectcount() > 0))? $c1 : $c_gray;
		imagerectangle($gp, $l, $y + 2, $c - 2, $y + $toolunit, $color);
		imagepolygon($gp, array($l + 5, $y + 11, $c - 7, $y + 11, $c - 5, $y + 13, $c - 7, $y + 15, $l + 5, $y + 15), 5, $color);
		imagesetthickness($gp, 3);
		imageline($gp, $l + 4, $y + 20, $l + 16, $y + 8, $color);
		imagesetthickness($gp, 1);
		
		if (($this->mode_edit == 1)&&($this->attr_point === null)) {
			imagesetthickness($gp, 2);
			imagerectangle($gp, $c + 1, $y + 3, $r - 1, $y + $toolunit - 1, $c1);
			imagesetthickness($gp, 1);
		} else {
			imagerectangle($gp, $c, $y + 2, $r, $y + $toolunit, $c1);
			foreach ($this->getselectlist() as $id)
				if ($raillist[$id]->getpointnumber() === null) {
					imagerectangle($gp, $c + 3, $y + 5, $r - 3, $y + $toolunit - 3, $c1);
					break;
				}
		}
		imagestring($gp, 4, $c + 8, $y + 4, "R", $c1);
		
		$y += $toolunit;
		
		$color = $c_gray;
		if ($this->mode_edit == 1) {
			if ($this->attr_point === null)
				$color = $c1;
		} else if ($this->selectcount() == 0)
			;
		else if ($raillist[$this->getselectone()]->getpointnumber() !== null)
			;
		else
			$color = $c1;
		imagerectangle($gp, $c, $y, $r, $y + 24, $color);
		imagestring($gp, 4, $c + 8, $y + 6, "T", $color);
		if (($this->mode_edit)&&($this->attr_train))
			imagefilledrectangle($gp, $c + 7, $y, $r - 7, $y + 4, $color);
		else if (($this->selectcount() > 0)&&($raillist[$this->getselectone()]->gettrainname() !== null))
			imagefilledrectangle($gp, $c + 7, $y, $r - 7, $y + 4, $color);
		else
			imagerectangle($gp, $c + 7, $y, $r - 7, $y + 4, $color);
		imageline($gp, $c, $y, $r, $y, $c1);
		
		$i = 0;
		for (;;) {
			$y += $toolunit;
			if ($y + $toolunit >= $screenh)
				break;
			
			$number = sprintf("%02x", $i);
			$status = $this->getstatus($number);
			$speed = null;
			if (($status == "P")||($status == "p"))
				$color = $c_point;
			else {
				$speed = $this->getspeed($number);
				if ($speed > 0)
					$color = $c_forward;
				else if ($speed < 0)
					$color = $c_backward;
				else
					$color = $c0;
			}
			imagefilledrectangle($gp, $l, $y, $r, $y + $toolunit, $color);
			
			imagestring($gp, 4, $l + 4, $y + 4, $number, $c1);
			if (($this->mode_edit == 0)&&($this->selectcount() == 0)) {
				imagefilledrectangle($gp, $l, $y + 14, $c - 14, $y + $toolunit, $c_gray);
				imagestring($gp, 1, $l + 2, $y + 16, "+", $c1);
			} else if ($speed === null) {
				imagefilledrectangle($gp, $l, $y + 14, $c - 14, $y + $toolunit, $c_gray);
				imagestring($gp, 1, $l + 2, $y + 16, "+", $c1);
			}
			if (($this->mode_edit == 1)&&($this->attr_rail === $number)) {
				imagesetthickness($gp, 2);
				imagerectangle($gp, $l + 1, $y + 1, $c - 1, $y + 23, $c1);
				imagesetthickness($gp, 1);
			} else {
				imagerectangle($gp, $l, $y, $c, $y + $toolunit, $c1);
				
				foreach ($this->getselectlist() as $id)
					if ($raillist[$id]->getnumber() === $number) {
						imagerectangle($gp, $l + 3, $y + 3, $c - 3, $y + $toolunit - 3, $c1);
						break;
					}
			}
			
			imagestring($gp, 4, $c + 8, $y + 4, $status, $c1);
			if (($this->mode_edit == 0)&&($this->selectcount() == 0)) {
				imagefilledrectangle($gp, $c, $y + 14, $r - 14, $y + $toolunit, $c_gray);
				imagestring($gp, 1, $c + 2, $y + 16, ">", $c1);
			} else if ($speed !== null) {
				imagefilledrectangle($gp, $c, $y + 14, $r - 14, $y + $toolunit, $c_gray);
				imagestring($gp, 1, $c + 2, $y + 16, "+", $c1);
			}
			if (($this->mode_edit == 1)&&($this->attr_point == $number)) {
				imagesetthickness($gp, 2);
				imagerectangle($gp, $c + 1, $y + 1, $r - 1, $y + 23, $c1);
				imagesetthickness($gp, 1);
			} else {
				imagerectangle($gp, $c, $y, $r, $y + $toolunit, $c1);
				$flag0 = $flag1 = 0;
				foreach ($this->getselectlist() as $id) {
					if ($raillist[$id]->getpointnumber() !== $number)
						continue;
					if ($raillist[$id]->isactive() == 1) {
						if ($flag0 == 0) {
							imagerectangle($gp, $c + 3, $y + 3, $r - 3, $y + $toolunit - 3, $c1);
							$flag0 = 1;
						}
					} else {
						if ($flag1 == 0) {
							imagerectangle($gp, $c + 2, $y + 2, $r - 2, $y + $toolunit - 2, IMG_COLOR_STYLED);
							$flag1 = 1;
						}
					}
					if (($flag0)&&($flag1))
						break;
				}
			}
			$i++;
		}
	}
	function	gethtml($mode = "") {
		global	$unit, $toolunit;
		global	$screenw, $screenh;
		global	$raillist;
		
		switch ($mode) {
			case	"toolscript":
				$ret = <<<EOO
case	0:
	if (e.pageX < {$toolunit})
		return command('mode=0');
	else
		return command('mode=1');

EOO;
				$cmd_r = "false";
				if ($this->mode_edit == 1) {
					if ($this->attr_point === null)
						$cmd_r = "command('train=".(1 - $this->attr_train)."')";
				} else if ($this->selectcount() == 0)
					;
				else if ($raillist[$this->getselectone()]->getpointnumber() !== null)
					;
				else if ($raillist[$this->getselectone()]->gettrainname() !== null)
					$cmd_r = "command('train=0')";
				else
					$cmd_r = "command('train=1')";
				$ret .= <<<EOO
case	1:
	if (e.pageX < {$toolunit})
		return command('delete');
	else
		return command('point=');
case	2:
	if (e.pageX < {$toolunit})
		return false;
	else
		return {$cmd_r};

EOO;
				$i = 0;
				$y = $toolunit * 2;
				for (;;) {
					$y += $toolunit;
					if ($y + $toolunit >= $screenh)
						break;
					
					$number = sprintf("%02x", $i);
					$ispoint = 0;
					switch ($this->getstatus($number)) {
						default:
							$newstatus = "A";
							break;
						case	"A":
							$newstatus = "D";
							break;
						case	"D":
							$newstatus = "d";
							break;
						case	"P":
							$newstatus = "p";
							$ispoint = 1;
							break;
						case	"p":
							$newstatus = "P";
							$ispoint = 1;
							break;
					}
					
					$cmd_l = $cmd_r =<<<EOO
command('{$number}={$newstatus}')
EOO;
					if (($this->mode_edit == 0)&&($this->selectcount() == 0))
						;
					else if (($ispoint))
						;
					else
						$cmd_l = <<<EOO
command('rail={$number}')
EOO;
					
					if (($this->mode_edit == 0)&&($this->selectcount() == 0))
						$cmd_r = <<<EOO
popup_type('{$number}', {$y})
EOO;
					else if ($ispoint == 0)
						;
					else
						$cmd_r = <<<EOO
command('point={$number}')
EOO;
					$pos = floor($y / $toolunit);
					$ret .= <<<EOO
case	{$pos}:
	if (e.pageX < {$toolunit})
		return {$cmd_l};
	else
		return {$cmd_r};

EOO;
					$i++;
				}
				return $ret;
			case	"selectrectscript":
				$ret = "";
				foreach ($this->getselectlist() as $id)
					$ret .= $raillist[$id]->gethtml("selectrectscript");
				if ($this->selectcount() == 1)
					$ret .= $raillist[$this->getselectone()]->gethtml("pickrectscript");
				return $ret;
			case	"selectscript":
				$ret = "";
				foreach ($this->getselectlist() as $id)
					$ret .= $raillist[$id]->gethtml("selectscript");
				return $ret;
			case	"selectdragscript":
				$l = $screenw;
				$t = $screenh;
				$r = $b = 0;
				foreach ($this->getselectlist() as $id)
					$raillist[$id]->getselectarea($l, $t, $r, $b);
				if (($l >= $r)||($t >= $b))
					return "";
				$width = $r - $l;
				$height = $b - $t;
				return <<<EOO
			selectrectobj.setAttribute("x", {$l} + (ex - sx) * {$unit});
			selectrectobj.setAttribute("y", {$t} + (ey - sy) * {$unit});
			selectrectobj.setAttribute("width", {$width});
			selectrectobj.setAttribute("height", {$height});

EOO;
		}
	}
	function	setcookie() {
		global	$url;
		
		$domain = "";
		$path = "";
		if (ereg('^([_0-9A-Za-z]+)://([-._%0-9A-Za-z]+)((/[-._%0-9A-Za-z]+)*/)([^/?]+)(\?.*)?$', $url, $array)) {
			$domain = $array[2];
			$path = $array[3];
		}
		$time = time() + 3600;
		setcookie("mode", $this->mode_edit."");
		setcookie("train", $this->attr_train."");
		setcookie("rail", $this->attr_rail."");
		setcookie("point", $this->attr_point."");
		
		$select = array();
		foreach ($this->getselectlist() as $id) {
			while (count($select) <= ($id >> 2))
				$select[] = 0;
			$select[$id >> 2] |= (1 << ($id & 3));
		}
		$selectstr = "";
		foreach ($select as $val)
			$selectstr .= sprintf("%01x", $val);
		setcookie("select", $selectstr);
	}
	function	intakecookie() {
		if (@$_COOKIE["mode"] == "1")
			$this->setmode(1);
		if (@$_COOKIE["train"] == "1")
			$this->settrain(1);
		if (ereg('^([0-9a-f]{2})', @$_COOKIE["rail"]."", $array))
			$this->setrail($array[1]);
		if (ereg('^([0-9a-f]{2})', @$_COOKIE["point"]."", $array))
			$this->setpoint($array[1]);
		if (ereg('^([0-9a-f]+)', @$_COOKIE["select"]."", $array)) {
			for ($i=0; $i<strlen($array[1]); $i++) {
				$val = ("0x".substr($array[1], $i, 1)) + 0;
				for ($j=0; $j<4; $j++)
					if (($val & (1 << $j)))
						$this->setselect($i * 4 + $j);
			}
		}
	}
}


#
# load config-file
#

if (($fp = @fopen($configfile, "r+")) === FALSE)
	$fp = fopen($configfile, "w+") or die("fopen failed.");
flock($fp, LOCK_EX) or die("flock failed.");

$newbody = "";
$railstartlist = array();
$raillist = array();
$railnumber = 0;
$trainlist = array();
$trainnamestring = "";
$systemstatus =& new systemstatus();
while (($line = fgets($fp)) !== FALSE) {
	if (ereg('^#', $line)) {
		$newbody .= trim($line)."\n";
		continue;
	}
	if (ereg('^R([0-9A-Fa-f]{2})((,[0-9]{4}){2,})', $line, $array)) {
		$str = $array[2];
		$end = substr($str, 1, 4);
		for ($i=6; $i+4<=strlen($str); $i+=5) {
			$start = $end;
			$end = substr($str, $i, 4);
			
			$obj =& new rail($array[1], $start, $end, count($raillist));
			if (@$railstartlist[$start] === null)
				$railstartlist[$start] = array();
			$railstartlist[$start][$end] =& $obj;
			$raillist[] =& $obj;
		}
		continue;
	}
	if (ereg('^([Pp])([0-9A-Fa-f]{2})([0-9A-Fa-f]{2})((,[0-9]{4}){2,})', $line, $array)) {
		$str = $array[4];
		$end = substr($str, 1, 4);
		for ($i=6; $i+4<=strlen($str); $i+=5) {
			$start = $end;
			$end = substr($str, $i, 4);
			
			$obj =& new point($array[3], $start, $end, $array[1], $array[2], count($raillist));
			if (@$railstartlist[$start] === null)
				$railstartlist[$start] = array();
			$railstartlist[$start][$end] =& $obj;
			$raillist[] =& $obj;
		}
		continue;
	}
	if (ereg('^T([A-Za-z]),([0-9]{4}),([0-9]{4}),([0-9]{2})', $line, $array)) {
		$trainlist[] = $array;
		$trainnamestring .= $array[1];
		continue;
	}
	if (ereg('^S([0-9]{4}),([A-Fa-fPp]+)', $line, $array)) {
		$systemstatus->setconfig($array[2]);
		continue;
	}
}

foreach ($trainlist as $array) {
	$name = $array[1];
	$start = $array[2];
	$end = $array[3];
	
	if (@$railstartlist[$start][$end] !== null)
		$railstartlist[$start][$end]->settrainname($name);
	else if (@$railstartlist[$end][$start] !== null)
		$railstartlist[$end][$start]->settrainname($name);
}

$systemstatus->intakecookie();

#
# execute command
#

$modify = 0;
do {
	if (($command = @$_POST["command"]) === null)
		break;
	$modify = -1;
	if (ereg('^mode=([01])', $command, $array)) {
		$systemstatus->setmode($array[1] + 0);
		break;
	}
	if (ereg('^rail=([0-9A-Fa-f]{2})', $command, $array)) {
		foreach ($systemstatus->getselectlist() as $id) {
			$raillist[$id]->setnumber($array[1]);
			$modify = 1;
		}
		$systemstatus->setrail($array[1]);
		break;
	}
	if (ereg('^point=([0-9A-Fa-f]{2})?', $command, $array)) {
		foreach ($systemstatus->getselectlist() as $id) {
			$obj =& $raillist[$id];
			$modify = 1;
			if (($point = $array[1]) == "") {
				$raillist[$id] =& new rail($obj->getnumber(), $obj->getstart(), $obj->getend(), $id);
				$raillist[$id]->settrainname($obj->gettrainname());
			} else {
				$type = "P";
				if ($systemstatus->getstatus($point) == "p")
					$type = "p";
				$raillist[$id] =& new point($obj->getnumber(), $obj->getstart(), $obj->getend(), $type, $point, $id);
			}
		}
		if (@$array[1]."" == "")
			$systemstatus->setpoint(null);
		else
			$systemstatus->setpoint($array[1]);
		break;
	}
	if (ereg('^train=([01])', $command, $array)) {
		foreach ($systemstatus->getselectlist() as $id) {
			if ($array[1] == 1)
				$raillist[$id]->settrainname("");
			else
				$raillist[$id]->settrainname(null);
			$modify = 1;
		}
		$systemstatus->settrain($array[1] + 0);
		break;
	}
	if (ereg('^([0-9a-f]{2})=([A-Fa-fPp])', $command, $array)) {
		$systemstatus->setstatus($array[1], $array[2]);
		$modify = 1;
		break;
	}
	if ($command === "delete") {
		foreach ($systemstatus->getselectlist() as $id)
			unset($raillist[$id]);
		$systemstatus->setselect(null);
		$modify = 1;
		break;
	}
	if ($command === "drawline") {
		$sx = max(0, min(99, intval(@$_POST["sx"])));
		$sy = max(0, min(99, intval(@$_POST["sy"])));
		$ex = max(0, min(99, intval(@$_POST["ex"])));
		$ey = max(0, min(99, intval(@$_POST["ey"])));
		
		if (($sx == $ex)&&($sy == $ey))
			break;
		
		if (($point = $systemstatus->attr_point) === null) {
			$rail = $systemstatus->attr_rail;
			$start = sprintf("%02d%02d", $sx, $sy);
			$end = sprintf("%02d%02d", $ex, $ey);
			$modify = 1;
			
			$obj =& new rail($rail, $start, $end, count($raillist));
		} else {
			$rail = $systemstatus->attr_rail;
			$start = sprintf("%02d%02d", $sx, $sy);
			$end = sprintf("%02d%02d", $ex, $ey);
			$type = "P";
			if ($systemstatus->getstatus($point) == "p")
				$type = "p";
			$modify = 1;
			
			$obj =& new point($rail, $start, $end, $type, $point, count($raillist));
		}
		if (@$railstartlist[$start] === null)
			$railstartlist[$start] = array();
		$railstartlist[$start][$end] =& $obj;
		$raillist[] =& $obj;
		
		if (($systemstatus->attr_train))
			$obj->settrainname("");
		
		$systemstatus->settrain(0);
		break;
	}
	if ($command === "alterline") {
		$sx = max(0, min(99, intval(@$_POST["sx"])));
		$sy = max(0, min(99, intval(@$_POST["sy"])));
		$ex = max(0, min(99, intval(@$_POST["ex"])));
		$ey = max(0, min(99, intval(@$_POST["ey"])));
		
		if (($sx == $ex)&&($sy == $ey))
			break;
		foreach ($systemstatus->getselectlist() as $id) {
			$start = sprintf("%02d%02d", $sx, $sy);
			$end = sprintf("%02d%02d", $ex, $ey);
			$raillist[$id]->setxy($start, $end);
			$modify = 1;
		}
		break;
	}
	if ($command === "dragselect") {
		$systemstatus->setmode(0);
		$systemstatus->setselect(null);
		$sx = intval(@$_POST["sx"]) + $offsetx;
		$sy = intval(@$_POST["sy"]) + $offsety;
		$ex = intval(@$_POST["ex"]) + $offsetx;
		$ey = intval(@$_POST["ey"]) + $offsety;
		
		if ((abs($sx - $ex) < $unit)&&(abs($sy - $ey) < $unit)) {
			foreach ($raillist as $id => $dummy)
				if (($raillist[$id]->pick($sx, $sy))) {
					$systemstatus->setselect($id);
					break;
				}
			break;
		}
		
		$l = min($sx, $ex);
		$t = min($sy, $ey);
		$r = max($sx, $ex);
		$b = max($sy, $ey);
		
		foreach ($raillist as $id => $dummy)
			if (($raillist[$id]->pick_rect($l, $t, $r, $b)))
				$systemstatus->setselect($id);
		break;
	}
	if ($command === "dragmove") {
		$x = intval(@$_POST["ex"]) - intval(@$_POST["sx"]);
		$y = intval(@$_POST["ey"]) - intval(@$_POST["sy"]);
		if (($x == 0)&&($y == 0))
			break;
		foreach ($systemstatus->getselectlist() as $id) {
			$s = $raillist[$id]->getstart();
			$sx = substr($s, 0, 2) + 0;
			$sy = substr($s, 2, 2) + 0;
			$s = $raillist[$id]->getend();
			$ex = substr($s, 0, 2) + 0;
			$ey = substr($s, 2, 2) + 0;
			
			$x = max($x, -min($sx, $ex));
			$x = min($x, 99 - max($sx, $ex));
			$y = max($y, -min($sy, $ey));
			$y = min($y, 99 - max($sy, $ey));
		}
		foreach ($systemstatus->getselectlist() as $id) {
			$s = $raillist[$id]->getstart();
			$sx = substr($s, 0, 2) + 0;
			$sy = substr($s, 2, 2) + 0;
			$s = $raillist[$id]->getend();
			$ex = substr($s, 0, 2) + 0;
			$ey = substr($s, 2, 2) + 0;
			
			$start = sprintf("%02d%02d", $sx + $x, $sy + $y);
			$end = sprintf("%02d%02d", $ex + $x, $ey + $y);
			$raillist[$id]->setxy($start, $end);
			$modify = 1;
		}
		break;
	}
} while ((0));

if ($modify > 0) {
	foreach ($raillist as $id => $dummy)
		$newbody .= $raillist[$id]->getconfig();
	$newbody .= $systemstatus->getconfig();
	
#	die("<PRE>".htmlspecialchars($newbody)."</PRE>");
	
	fseek($fp, 0, SEEK_SET);
	ftruncate($fp, 0);
	fwrite($fp, $newbody);
	
	flock($fp, LOCK_UN);
	fclose($fp);
}
if (($modify)) {
	$systemstatus->setcookie();
	header("Location: ".$url);
	die();
}

#
# create result
#

if ($query == "__image") {
	$gp0 = imagecreatetruecolor($screenw, $screenh) or die("imagecreate failed.");
	$c0 = imagecolorresolve($gp0, 0xff, 0xff, 0xff);
	$c1 = imagecolorresolve($gp0, 0xe0, 0xe0, 0xe0);
	imagefilledrectangle($gp0, 0, 0, $screenw, $screenh, $c0);
	
	for ($i=0; $i<100; $i+=10)
		imagefilledrectangle($gp0, $offsetx, $offsety + $unit * $i, $offsetx + $unit * 100, $offsety + $unit * ($i + 1), $c1);
	for ($i=0; $i<100; $i+=10)
		imagefilledrectangle($gp0, $offsetx + $unit * $i, $offsety, $offsetx + $unit * ($i + 1), $offsety + $unit * 100, $c1);
	
	foreach ($raillist as $id => $dummy)
		$raillist[$id]->draw($gp0);
	foreach ($raillist as $id => $dummy)
		$raillist[$id]->drawtrain($gp0);
	
	$systemstatus->draw($gp0);
	
	# for opera
	header("Cache-Control: no-cache");
	header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
	
	header("Content-Type: image/png");
	imagepng($gp0);
	imagedestroy($gp0);
	die();
}

if ($query == "") {
	$systemstatus->setcookie();
	$toolscript = $systemstatus->gethtml("toolscript");
	$selectscript = "";
	$selectrectscript = "";
	$selectdragscript = "";
	if ($systemstatus->mode_edit == 0) {
		$dragmode = "dragselect";
		$selectscript = $systemstatus->gethtml("selectscript");
		$selectrectscript = $systemstatus->gethtml("selectrectscript");
		$selectdragscript = $systemstatus->gethtml("selectdragscript");
	} else {
		$dragmode = "dragline";
	}
	
	print <<<EOO
<HTML><HEAD><TITLE>{$scriptname} {$scriptversion}</TITLE>
<!-- with reference to http://musicgroupwork.at.webry.info/200701/article_2.html -->
<!-- with reference to http://jsm.suepon.com/script/jsm31.html -->
<script type="text/javascript"><!--

workspaceobj = null;
containerobj = null;
selectobj = null;
lineobj = null;
popuprectobj = null;
pickrectobj_s = null;
pickrectobj_e = null;
selectrectobj = null;
selectrectlist = null;
popupobj = null;
popupnumber = "";
popupy = 0;
popupresult = "";
linestatus = 1;
sx = sy = ex = ey = 0;


function	lineblink()
{
	objlist = selectobj.getElementsByTagName("rect");
	switch (linestatus) {
		case	0:
			pickrectobj_s.setAttribute("fill", "none");
			pickrectobj_e.setAttribute("fill", "none");
			for (i=0; i<objlist.length; i++)
				objlist[i].setAttribute("stroke-width", "0");
			break;
		case	1:
			pickrectobj_s.setAttribute("fill", "black");
			pickrectobj_e.setAttribute("fill", "black");
			for (i=0; i<objlist.length; i++)
				objlist[i].setAttribute("stroke-width", "2");
		case	2:
			linestatus = 3;
			for (i=0; i<objlist.length; i++)
				objlist[i].setAttribute("stroke-dasharray", "0,4,4,0");
			break;
		case	3:
			linestatus = 2;
			for (i=0; i<objlist.length; i++)
				objlist[i].setAttribute("stroke-dasharray", "4,4");
			break;
	}
}


function	presstool(e) {
	switch (parseInt(e.pageY / {$toolunit})) {
{$toolscript}
	}
	return false;
}


function	dragline(e)
{
	if (e.pageX < {$offsetx})
		return presstool(e);
	
	sx = parseInt((e.pageX - {$offsetx}) / {$unit});
	sy = parseInt((e.pageY - {$offsety}) / {$unit});
	if ((sx < 0)||(sx > 99)||(sy < 0)||(sy > 99))
		return;
	lineobj.setAttribute("x1", sx * {$unit} + {$unit} / 2 + {$offsetx});
	lineobj.setAttribute("y1", sy * {$unit} + {$unit} / 2 + {$offsety});
	ex = -1;
	document.onmousemove = function(e) {
		ex = parseInt((e.pageX - {$offsetx}) / {$unit});
		ey = parseInt((e.pageY - {$offsety}) / {$unit});
		if ((ex < 0)||(ex > 99)||(ey < 0)||(ey > 99)||((sx == ex)&&(sy == ey))) {
			ex = -1;
			lineobj.setAttribute("stroke-width", "0");
		} else {
			lineobj.setAttribute("x2", ex * {$unit} + {$unit} / 2 + {$offsetx});
			lineobj.setAttribute("y2", ey * {$unit} + {$unit} / 2 + {$offsety});
			lineobj.setAttribute("stroke-width", "3");
		}
		return false;
	};
	document.onmouseup = function(e) {
		document.onmousemove(e);
		lineobj.setAttribute("stroke-width", "0");
		document.onmouseup = null;
		document.onmousemove = null;
		if (ex < 0)
			;
		else {
			document.forms[0].command.value = "drawline";
			document.forms[0].sx.value = sx;
			document.forms[0].sy.value = sy;
			document.forms[0].ex.value = ex;
			document.forms[0].ey.value = ey;
			document.forms[0].submit();
		}
	};
	return false;
}


function	dragalter_s(e)
{
	ex = document.forms[0].ex.value;
	ey = document.forms[0].ey.value;
	lineobj.setAttribute("x1", ex * {$unit} + {$unit} / 2 + {$offsetx});
	lineobj.setAttribute("y1", ey * {$unit} + {$unit} / 2 + {$offsety});
	document.onmousemove = function(e) {
		sx = parseInt((e.pageX - {$offsetx}) / {$unit});
		sy = parseInt((e.pageY - {$offsety}) / {$unit});
		if ((sx < 0)||(sx > 99)||(sy < 0)||(sy > 99)||((sx == ex)&&(sy == ey))) {
			sx = -1;
			lineobj.setAttribute("stroke-width", "0");
		} else {
			lineobj.setAttribute("x2", sx * {$unit} + {$unit} / 2 + {$offsetx});
			lineobj.setAttribute("y2", sy * {$unit} + {$unit} / 2 + {$offsety});
			lineobj.setAttribute("stroke-width", "3");
		}
		return false;
	};
	document.onmousemove(e);
	document.onmouseup = function(e) {
		document.onmousemove(e);
		lineobj.setAttribute("stroke-width", "0");
		document.onmouseup = null;
		document.onmousemove = null;
		if (sx < 0) {
			linestatus = 1;
			lineblink();
		} else {
			document.forms[0].command.value = "alterline";
			document.forms[0].sx.value = sx;
			document.forms[0].sy.value = sy;
			document.forms[0].submit();
		}
	};
	return false;
}


function	dragalter_e(e)
{
	sx = document.forms[0].sx.value;
	sy = document.forms[0].sy.value;
	lineobj.setAttribute("x1", sx * {$unit} + {$unit} / 2 + {$offsetx});
	lineobj.setAttribute("y1", sy * {$unit} + {$unit} / 2 + {$offsety});
	document.onmousemove = function(e) {
		ex = parseInt((e.pageX - {$offsetx}) / {$unit});
		ey = parseInt((e.pageY - {$offsety}) / {$unit});
		if ((ex < 0)||(ex > 99)||(ey < 0)||(ey > 99)||((sx == ex)&&(sy == ey))) {
			ex = -1;
			lineobj.setAttribute("stroke-width", "0");
		} else {
			lineobj.setAttribute("x2", ex * {$unit} + {$unit} / 2 + {$offsetx});
			lineobj.setAttribute("y2", ey * {$unit} + {$unit} / 2 + {$offsety});
			lineobj.setAttribute("stroke-width", "3");
		}
		return false;
	};
	document.onmousemove(e);
	document.onmouseup = function(e) {
		document.onmousemove(e);
		lineobj.setAttribute("stroke-width", "0");
		document.onmouseup = null;
		document.onmousemove = null;
		if (ex < 0) {
			linestatus = 1;
			lineblink();
		} else {
			document.forms[0].command.value = "alterline";
			document.forms[0].ex.value = ex;
			document.forms[0].ey.value = ey;
			document.forms[0].submit();
		}
	};
	return false;
}


function	dragmove(e)
{
	sx = parseInt((e.pageX - {$offsetx}) / {$unit});
	sy = parseInt((e.pageY - {$offsety}) / {$unit});
	if ((sx < 0)||(sx > 99)||(sy < 0)||(sy > 99))
		return;
	document.onmousemove = function(e) {
		ex = parseInt((e.pageX - {$offsetx}) / {$unit});
		ey = parseInt((e.pageY - {$offsety}) / {$unit});
		if ((ex < 0)||(ex > 99)||(ey < 0)||(ey > 99)) {
			ex = -1;
			selectrectobj.setAttribute("stroke-width", "0");
		} else {
{$selectdragscript}
			selectrectobj.setAttribute("stroke-width", "2");
		}
		return false;
	};
	document.onmousemove(e);
	document.onmouseup = function(e) {
		document.onmousemove(e);
		selectrectobj.setAttribute("stroke-width", "0");
		document.onmouseup = null;
		document.onmousemove = null;
		if (ex < 0) {
			linestatus = 1;
			lineblink();
		} else {
			document.forms[0].command.value = "dragmove";
			document.forms[0].sx.value = sx;
			document.forms[0].sy.value = sy;
			document.forms[0].ex.value = ex;
			document.forms[0].ey.value = ey;
			document.forms[0].submit();
		}
	};
	return false;
}


function	dragselect(e)
{
	if (e.pageX < {$offsetx})
		return presstool(e);
	
	linestatus = 0;
	lineblink();
	
	x = parseInt((e.pageX - {$offsetx}) / {$unit});
	y = parseInt((e.pageY - {$offsety}) / {$unit});
	if ((x == document.forms[0].sx.value)&&(y == document.forms[0].sy.value))
		return dragalter_s(e);
	if ((x == document.forms[0].ex.value)&&(y == document.forms[0].ey.value))
		return dragalter_e(e);
{$selectscript}
	
	sx = e.pageX - {$offsetx};
	sy = e.pageY - {$offsety};
	if ((sx < 0)||(sx >= {$unit} * 100)||(sy < 0)||(sy >= {$unit} * 100))
		return;
	document.onmousemove = function(e) {
		ex = e.pageX - {$offsetx};
		ey = e.pageY - {$offsety};
		if ((ex < 0)||(ex >= {$unit} * 100)||(ey < 0)||(ey >= {$unit} * 100)) {
			ex = -1;
			selectrectobj.setAttribute("stroke-width", "0");
		} else {
			selectrectobj.setAttribute("x", Math.min(sx, ex) - 1 + {$offsetx});
			selectrectobj.setAttribute("y", Math.min(sy, ey) - 1 + {$offsety});
			selectrectobj.setAttribute("width", Math.abs(ex - sx) + 3);
			selectrectobj.setAttribute("height", Math.abs(ey - sy) + 3);
			selectrectobj.setAttribute("stroke-width", "2");
		}
		return false;
	};
	document.onmouseup = function(e) {
 		document.onmousemove(e);
		selectrectobj.setAttribute("stroke-width", "0");
		document.onmouseup = null;
		document.onmousemove = null;
		if (ex < 0) {
			linestatus = 1;
			lineblink();
		} else {
			document.forms[0].command.value = "dragselect";
			document.forms[0].sx.value = sx;
			document.forms[0].sy.value = sy;
			document.forms[0].ex.value = ex;
			document.forms[0].ey.value = ey;
			document.forms[0].submit();
		}
	};
	return false;
}


function	popup_type(number, y)
{
	popupnumber = number;
	popupy = y;
	popupobj = document.getElementById("popuptype");
	popupobj.style.top = y + "px";
	popupobj.style.left = ({$toolunit} * 2) + "px";
	popuprectobj.setAttribute("y", y + 4);
	popuprectobj.setAttribute("width", "16");
	popuprectobj.setAttribute("height", "16");
	document.onmousemove = function(e) {
		x = 0;
		popupresult = "";
		if ((e.pageY < popupy + 4)||(e.pageY >= popupy + 20))
			;
		else if (e.pageX < {$toolunit} * 2 + 4)
			;
		else if (e.pageX < {$toolunit} * 3) {
			x = {$toolunit} * 2;
			popupresult = popupnumber + "=A";
		} else if (e.pageX < {$toolunit} * 4) {
			x = {$toolunit} * 3;
			popupresult = popupnumber + "=P";
		} else if (e.pageX < {$toolunit} * 5 - 4){
			x = {$toolunit} * 4;
			popupresult = popupnumber + "=p";
		}
		if (x == 0)
			popuprectobj.setAttribute("stroke-width", "0");
		else {
			popuprectobj.setAttribute("x", x + 4);
			popuprectobj.setAttribute("stroke-width", "2");
		}
		return false;
	};
	document.onmouseup = function(e) {
		document.onmousemove(e);
		document.onmouseup = null;
		document.onmousemove = null;
		popupobj.style.left = "-100px";
		popuprectobj.setAttribute("stroke-width", "0");
		if (popupresult == "")
			return false;
		return command(popupresult);
	};
	return false;
}


window.onload = function() {
	document.onmouseup = null;
	document.onmousemove = null;
	
	lineobj = document.createElementNS("http://www.w3.org/2000/svg", "line");
	lineobj.setAttribute("stroke", "black");
	lineobj.setAttribute("stroke-width", "0");
	
	pickrectobj_s = document.createElementNS("http://www.w3.org/2000/svg", "rect");
	pickrectobj_s.setAttribute("stroke", "none");
	pickrectobj_s.setAttribute("fill", "none");
	pickrectobj_s.setAttribute("stroke-width", "0");
	pickrectobj_s.setAttribute("x", 0);
	pickrectobj_s.setAttribute("width", 0);
	
	pickrectobj_e = document.createElementNS("http://www.w3.org/2000/svg", "rect");
	pickrectobj_e.setAttribute("stroke", "none");
	pickrectobj_e.setAttribute("fill", "black");
	pickrectobj_e.setAttribute("stroke-width", "0");
	pickrectobj_e.setAttribute("x", 0);
	pickrectobj_e.setAttribute("width", 0);
	
	popuprectobj = document.createElementNS("http://www.w3.org/2000/svg", "rect");
	popuprectobj.setAttribute("stroke", "black");
	popuprectobj.setAttribute("fill", "none");
	popuprectobj.setAttribute("stroke-width", "0");
	
	selectrectobj = document.createElementNS("http://www.w3.org/2000/svg", "rect");
	selectrectobj.setAttribute("stroke", "black");
	selectrectobj.setAttribute("fill", "none");
	selectrectobj.setAttribute("stroke-width", "0");
	selectrectobj.setAttribute("stroke-dasharray", "4,4");
	
	containerobj = document.createElementNS("http://www.w3.org/2000/svg", "svg");
	containerobj.appendChild(lineobj);
	containerobj.appendChild(pickrectobj_s);
	containerobj.appendChild(pickrectobj_e);
	containerobj.appendChild(popuprectobj);
	containerobj.appendChild(selectrectobj);
	
	workspaceobj = document.getElementById("workspace");
	workspaceobj.appendChild(containerobj);
	workspaceobj.onmousedown = {$dragmode};
	
	selectobj = document.createElementNS("http://www.w3.org/2000/svg", "svg");
	document.getElementById("selectarea").appendChild(selectobj);
{$selectrectscript}
	
	lineblink();
	setInterval(lineblink, 1000);
}


function	command(s)
{
	document.forms[0].command.value = s;
	document.forms[0].submit();
}


// --></script>
</HEAD><BODY><DIV>
<IMG src="?__image" style="position: absolute; left:0; top:0; border:0;">
<IMG src="?__image_type" alt="" id="popuptype" style="position: absolute; left:-100px;">
<DIV id="selectarea" style="position: absolute; left:0; top:0px; width:{$screenw}px; height:{$screenh}px;"></DIV>
<DIV id="workspace" style="position: absolute; left:0; top:0px; width:{$screenw}px; height:{$screenh}px;"></DIV>
</DIV>
<FORM method=post>
<INPUT type=hidden name=command value="">
<INPUT type=hidden name=sx>
<INPUT type=hidden name=sy>
<INPUT type=hidden name=ex>
<INPUT type=hidden name=ey>
</FORM>
</BODY></HTML>
EOO;
	die();
}



?>